proc sort data=base_unc;
	by &sect;
proc glm data=base_unc;
	by &sect;
	class hs6;
	model dlp2=hs6 s2hat pshat   /noint solution  ; 
	ods output ParameterEstimates=work.sol_unc ;* sol_unc contains the parameter estimates (by &sect, 4coef+intercepts);
run;quit;
* compute residuals of the unconstrained estimation;
data EF;
	set sol_unc;
	if Parameter="s2hat" then delete;
	if Parameter="pshat" then delete;
	hs6=substr(Parameter,11,6);
run;* keep the sector-specific intercepts;
proc sort data=EF;
	by hs6;
proc sort data=base_unc;
	by hs6;
data base_unc;
	merge base_unc EF(keep=hs6 estimate);* add sector-specific intercepts in base;
	by hs6;
data s2hat;
	set sol_unc;
	where Parameter="s2hat";
	coef_s2hat=estimate;
data pshat;
	set sol_unc;
	where Parameter="pshat";
	coef_pshat=estimate;
proc sort data=base_unc;
	by &sect;
proc sort data=s2hat;
	by &sect;
proc sort data=pshat;
	by &sect;
data base_unc;
	merge base_unc s2hat(keep=coef_s2hat &sect) pshat(keep=coef_pshat &sect);
	by &sect;* add estimated coef in base;
	res=dlp2-estimate-coef_s2hat*dls2-coef_pshat*dlps;
	res2=res*res;
run;
